#!/usr/bin/env bash

TYPE_SPEED="${TYPE_SPEED:-15}"
PROMPT_TIMEOUT="${PROMPT_TIMEOUT:--1}"

function simtyping()
{ pv -qL $(($TYPE_SPEED+$((-2 + RANDOM%5)))); }

function wait()
{
    if [ "$PROMPT_TIMEOUT" == "-1" ]; then
        read -rs
    else
        read -rst "$PROMPT_TIMEOUT"
    fi
}

function type()
{ printf "$*" | simtyping; }

function prompt() 
{
    def="\033[0;00m"
    blu="\033[0;34m"
    cyn="\033[0;36m"
    printf "[$cyn$(whoami)$def@$blu$(hostname)$def $(basename `pwd`)]\$ "; 
}

function execute()
{
    prompt
    type "$@" && wait
    printf "\n"
    eval "$@"
}

function cmd()
{
    while : ; do
        prompt
        read command
        [ "$command" != "end" ] && eval "${command}" || break
        [ "$1" ] && break
    done
}
